unit bardemostate;

{$ifdef FPC}
{$mode objFPC}
{$endif}

{$h+}

interface

uses  SDL,sysutils,classes,
      S2DLImage,S2DLNeheFont,S2DLDraws,S2DLState;

const max_bars=32;

type  Tcolour_bar_type=(bt_gradient_down,bt_gradient_up);
      colour_bar=record
        y_position,y_size:word;
        bar_type:Tcolour_bar_type;
        r,g,b,a:single;
      end;

      Pbar_list=^bar_list;
      bar_list=array[1..max_bars] of colour_bar;

type Tbardemo_state=class(TGameStateImage)
     private
       colour_bars:Pbar_list;
       colour_bar_count:cardinal;
       Fgradient_up:TS2DLimage;
       Fgradient_down:TS2DLimage;
       Ffont:TS2DLNeheFont;
       Fdelay,Fdelay_time:longint;
       procedure DoDraw;override;
       procedure DoendState;override;
       procedure DoInput;override;
       procedure DoStartState;override;
       procedure DoUpdate(GameTime:integer);override;
     public
       property gradient_up:TS2DLimage read Fgradient_up write Fgradient_up;
       property gradient_down:TS2DLimage read Fgradient_down write Fgradient_down;
       property font:TS2DLNeheFont read Ffont write Ffont;
       property delay:longint read Fdelay write Fdelay;
       property delay_time:longint read Fdelay_time write Fdelay_time;
       constructor create;
       destructor destroy;override;
     end;

implementation

{ Tbardemo_state }
constructor Tbardemo_state.create;

begin
  inherited create;
  new(colour_bars);
  delay:=20;
  colour_bar_count:=0;
end;

procedure Tbardemo_state.DoStartState();

begin
  inherited DoStartState();
  delay_time:=-1;
end;

procedure Tbardemo_state.DoendState();

begin
  active:=false;
  inherited DoendState();
end;

procedure Tbardemo_state.DoUpdate(GameTime:longint);

var i:longint;
    y_pos:word;

begin
  inherited DoUpdate(gameTime);

  {Do some iterations.}
{  for i:=1 to gametime*4 do
    if coordinate_count<max_coordinate then
      begin
        iteration(coordx,coordy);
        inc(coordinate_count);
        coordinates^[coordinate_count].x:=coordx;
        coordinates^[coordinate_count].y:=coordy;
      end;}
  y_pos:=300+round(100*sin(delay_time/720));
  colour_bar_count:=2;
  with colour_bars^[1] do
    begin
      y_position:=y_pos-50;
      y_size:=50;
      bar_type:=bt_gradient_down;
      r:=0;
      g:=1;
      b:=0;
      a:=0.5
    end;
  with colour_bars^[2] do
    begin
      y_position:=y_pos;
      y_size:=50;
      bar_type:=bt_gradient_up;
      r:=0;
      g:=1;
      b:=0;
      a:=0.5
    end;

  delay_time:=delay_time+gameTime;
  if delay_time>delay*1000 then
    DoendState();
end;

procedure Tbardemo_state.DoDraw();

var s:integer;
    i:cardinal;

begin
  inherited DoDraw();

  for i:=1 to colour_bar_count do
    with colour_bars^[i] do
      begin
        S2DLdraw.tempcolor(r,g,b);
        case bar_type of
          bt_gradient_up:
            gradient_up.drawstretchRGBA(0,y_position,800,y_size,r,g,b,a);
          bt_gradient_down:
            gradient_down.drawstretchRGBA(0,y_position,800,y_size,r,g,b,a);
        end;
      end;

  S2DLdraw.tempcolor(1,1,1);
  font.WriteText(200, 0, GameTitle, 1);
  s:=delay_time div 1000;
  font.WriteTextStretch(0,0,0.5,'Seconds:'+IntToStr(S));
  font.WriteTextStretch(0,50,0.5,'FPS:'+IntToStr(S2DLDraw.FPS));
end;

procedure Tbardemo_state.DoInput();

begin
  Inherited DoInput();
  if mouse.LeftPressed then
    DoendState();
end;

destructor Tbardemo_state.destroy;

begin
  dispose(colour_bars);
end;

end.

