unit diastaat;

{$mode objFPC}

interface

uses  SDL,sysutils,classes,
      S2DLImage,S2DLNeheFont,S2DLDraws,S2DLState,
      presglobals;

type Tdia_staat=class(TGameState)
     private
       Ffont:TS2DLNeheFont;
       Fdelay,delay_time,fade_out_start:longint;
       Fregels:Tstringlist;
       Flogo_beeld:integer;
       return_after_fade:integer;
       procedure DoDraw;override;
       procedure DoendState;override;
       procedure DoInput;override;
       procedure DoStartState;override;
       procedure DoUpdate(GameTime:integer);override;
     public
       logo,balkboven,mouseimg:TS2DLimage;
       property font:TS2DLNeheFont read Ffont write Ffont;
       property delay:longint read Fdelay write Fdelay;
       constructor create(const bestandsnaam:string);
       destructor destroy;override;
     end;

implementation

constructor Tdia_staat.create(const bestandsnaam:string);

begin
  inherited create;
  delay:=20;
  Fregels:=Tstringlist.create;
  Fregels.loadfromfile(bestandsnaam);
  Flogo_beeld:=0;
end;

procedure Tdia_staat.DoStartState();

begin
  inherited DoStartState();
  s2dldraw.clearcolor(1.0,1.0,1.0);
  delay_time:=-1;
  returncode:=rt_continue;
  fade_out_start:=1000000000;;
end;

procedure Tdia_staat.DoendState();

begin
  active:=false;
  inherited DoendState();
end;

procedure Tdia_staat.DoUpdate(GameTime:longint);

var i:longint;
    coordx,coordy:word;

begin
  inherited DoUpdate(gameTime);
  delay_time:=delay_time+gameTime;
  if delay_time>fade_out_start+1500 then
    returncode:=return_after_fade;
end;

procedure Tdia_staat.DoDraw();

var s:integer;
    i,n:cardinal;
    init_factor,init_factor2,fade_out_factor,fade_out_factor2:single;

const beeld_index:array[0..7] of byte=(2,1,0,3,4,5,6,7);

begin
  inherited DoDraw();

  inc(Flogo_beeld);
  s2dldraw.clearcolor(1,1,1);
  s2dldraw.clear;

  if delay_time>0 then
    n:=delay_time
  else
    n:=1;

  if n<1000 then
    init_factor:=n/1000
  else
    init_factor:=1;

  if delay_time>fade_out_start then
    fade_out_factor:=(delay_time-fade_out_start)/1000
  else
    fade_out_factor:=1;

  init_factor2:=init_factor*init_factor;
  fade_out_factor2:=fade_out_factor*fade_out_factor;

  s2dldraw.setcolor(1,1,1,1);
  balkboven.drawtiled(0,0,25,1);
  logo.draw(650,60,beeld_index[(Flogo_beeld shr 3) and 7]);

  if fade_out_factor=1 then
    s2dldraw.setcolor(0.15,0.19,0.50,init_factor2)
  else
    s2dldraw.setcolor(0.15,0.19,0.50,1-fade_out_factor2);

  font.writetextstretch(50,50,1.2/init_factor,'free pascal');

  if fade_out_factor=1 then
    s2dldraw.setcolor(1/15,1/15,1/15,init_factor)
  else
    s2dldraw.setcolor(1/15,1/15,1/15,1-fade_out_factor);
  for i:=1 to Fregels.count do
    begin
      if fade_out_factor=1 then
        font.writetextstretch(150-trunc(400*(1-init_factor2)),150+(i-1)*25,0.5,Fregels[i-1])
      else
        font.writetextstretch(150+trunc(400*fade_out_factor2),150+(i-1)*25,0.5,Fregels[i-1])
    end;

  s2dldraw.setcolor(0,0,0,1);
  s:=delay_time div 1000;
  font.WriteTextStretch(0,586,0.25,'FPS:'+IntToStr(S2DLDraw.FPS));

  s2dldraw.setcolor(1,0,0,1);
  mouseimg.draw(mouse.x-16,mouse.y-16);
end;

procedure Tdia_staat.DoInput();

begin
  Inherited DoInput();
  if keyboard.keystate[SDLK_LEFT] or mouse.rightbutton then
    begin
      fade_out_start:=delay_time;
      return_after_fade:=rt_vorige_dia;
    end;
  if (keyboard.keystate[SDLK_RIGHT]) or (keyboard.keystate[SDLK_SPACE]) or
     mouse.leftbutton then
    begin
      fade_out_start:=delay_time;
      return_after_fade:=rt_volgende_dia;
    end;
  if keyboard.keystate[SDLK_UP] then
    returncode:=rt_vorige_dia_snel;
  if keyboard.keystate[SDLK_DOWN] then
    returncode:=rt_volgende_dia_snel;
end;

destructor Tdia_staat.destroy;

begin
  Fregels.destroy;
end;

end.

