program presentatie;

{$mode objfpc}

Uses
  S2DLDraws,S2DLImage,S2DLNeheFont,
  S2DLState,diastaat,titeldia,plaatjesdia,presglobals,classes;

Const
  gstitel =  0;
  gsdia1  =  1;
  gsdia2  =  2;
  gsdia3  =  3;
  gsdia4  =  4;
  gsdia5  =  5;
  gsdia6  =  6;
  gsdia7  =  7;
  gsdia8  =  8;
  gsdia9  =  9;
  gsdia10 = 10;
  gsdia11 = 11;
  gsdia12 = 12;
  gsdia13 = 13;
  gsdia14 = 14;
  gsdia15 = 15;
  gsdia16 = 16;
  gsdia17 = 17;
  gsdia18 = 18;
  gsdia19 = 19;
  gsEnd   = 99;

  eerste_dia  = 1;
  laatste_dia = 19;

type  Tpresentatie=class
      private
        SplashState : TGameStateSplash;
        FGameState: Integer;
        dias:Tlist;
        titel:Ttiteldia;
        procedure SetGameState(const Value: Integer);
      public
        property GameState : Integer read FGameState write SetGameState;
        state:TGameState;
        constructor create;
        procedure laad_tekstdia(const s:string);
        procedure laad_plaatjesdia(const i:TS2DLimage;const s:string);
        procedure presenteer;
        procedure LoadImages;
        procedure EndState(InState : TObject);
        destructor destroy;override;
      end;

constructor Tpresentatie.create;

begin
  S2DLDraw.WindowCaption('Free Pascal 2.2');
  LoadImages;

  titel:=Ttiteldia.create;
  titel.font:=Fonts[0];
  titel.titelimg:=images[3];
  titel.balkboven:=images[1];
  titel.mouseimg:=images[2];
  titel.OnEndState:={$ifdef FPC}@{$endif}EndState;
    

  dias:=Tlist.create;
  laad_tekstdia('dia01.txt');
  laad_tekstdia('dia01a.txt');
  laad_tekstdia('dia02.txt');
  laad_tekstdia('dia03.txt');
  laad_tekstdia('dia04.txt');
  laad_tekstdia('dia05.txt');
  laad_tekstdia('dia06.txt');
  laad_tekstdia('dia07.txt');
  laad_tekstdia('dia08.txt');
  laad_tekstdia('dia09.txt');
  laad_tekstdia('dia10.txt');
  laad_tekstdia('dia11.txt');
  laad_tekstdia('dia12.txt');
  laad_tekstdia('dia13.txt');
  laad_tekstdia('dia14.txt');
  laad_tekstdia('dia15.txt');
  laad_plaatjesdia(images[4],'Shootout, relatieve looptd');
  laad_plaatjesdia(images[5],'Shootout, relatief geheugengebruik');
  laad_tekstdia('dia18.txt');
  
  state:=titel;
  gamestate:=gstitel;
end;

procedure Tpresentatie.laad_tekstdia(const s:string);

var dia_staat:Tdia_staat;

begin
  dia_staat:=Tdia_staat.create(s);
  dia_staat.font:=Fonts[0];
  dia_staat.logo:=images[0];
  dia_staat.balkboven:=images[1];
  dia_staat.mouseimg:=images[2];
  dia_staat.OnEndState:={$ifdef FPC}@{$endif}EndState;

  dias.add(dia_staat);
end;

procedure Tpresentatie.laad_plaatjesdia(const i:TS2DLimage;const s:string);

var dia_staat:Tplaatjesdia;

begin
  dia_staat:=Tplaatjesdia.create(s);
  dia_staat.font:=Fonts[0];
  dia_staat.logo:=images[0];
  dia_staat.balkboven:=images[1];
  dia_staat.mouseimg:=images[2];
  dia_staat.plaatje:=i;
  dia_staat.OnEndState:={$ifdef FPC}@{$endif}EndState;

  dias.add(dia_staat);
end;

procedure Tpresentatie.LoadImages;
begin
  Images.LoadImage('logo.png');
  Images[0].PatternWidth := 256;
  Images[0].PatternHeight := 64;
  Images.LoadImage('balk_boven.png');
  Images[1].PatternWidth := 32;
  Images[1].PatternHeight := 64;
  Images.LoadImage('gloed.png');
  Images[2].PatternWidth := 16;
  Images[2].PatternHeight := 16;
  Images.LoadImage('luipaard.png');
  Images[3].PatternWidth := 512;
  Images[3].PatternHeight := 256;
  Images.LoadImage('cpu.png');
  Images[4].PatternWidth := 1024;
  Images[4].PatternHeight := 1024;
  Images.LoadImage('memory.png');
  Images[5].PatternWidth := 1024;
  Images[5].PatternHeight := 1024;
  Fonts.LoadFromFile('trebuchet.png','Trebuchet MS');
  Fonts[0].LoadIni('trebuchet.ini');
end;

procedure Tpresentatie.EndState(InState: TObject);
begin
  if (gamestate>=0) and (gamestate<=laatste_dia) then
    begin
      case Tgamestate(instate).returncode of
        rt_quit:
          gamestate:=gsend;
        rt_vorige_dia_snel,
        rt_vorige_dia:
          if gamestate>eerste_dia then
            dec(gamestate)
          else
            gamestate:=gsend;
        rt_volgende_dia,
        rt_volgende_dia_snel:
          if gamestate<laatste_dia then
            inc(gamestate)
          else
            gamestate:=gsend;
      end;
    end
  else
    gamestate:=gsend;
  case gamestate of
    gstitel:
      state:=titel;
    eerste_dia..laatste_dia:
      state:=Tgamestate(dias[gamestate-eerste_dia]);
  end;
end;

procedure Tpresentatie.presenteer;

begin
  writeln('Gamestate: ',gamestate);
  Repeat
    state.dostartstate;
    while state.returncode=rt_continue do
      begin
        state.Input;
        state.Update;
        state.Draw;
      end;
    state.doendstate;
    writeln('Eind, code: ',state.returncode);
    If State.ReturnCode=rt_quit then
      GameState := gsEnd;
    writeln('Gamestate: ',gamestate);
  Until GameState = gsEnd;
end;

procedure Tpresentatie.SetGameState(const Value: Integer);

begin
  FGameState := Value;
end;

destructor Tpresentatie.destroy;

begin
  titel.free;
  dias.free;
end;

var pres:Tpresentatie;

begin
  pres:=Tpresentatie.Create;
  pres.presenteer;
  pres.free;
end.
