unit titeldia;

{$mode objFPC}

interface

uses  SDL,sysutils,classes,
      S2DLImage,S2DLNeheFont,S2DLDraws,S2DLState,
      presglobals;

type Ttiteldia=class(TGameState)
     private
       Ffont:TS2DLNeheFont;
       slagzinnen:Tstringlist;
       Fdelay,delay_time,fade_out_start:longint;
       huidige_slagzin,huidige_slagzin_start:longint;
       return_after_fade:integer;
       procedure DoDraw;override;
       procedure DoendState;override;
       procedure DoInput;override;
       procedure DoStartState;override;
       procedure DoUpdate(GameTime:integer);override;
     public
       balkboven,mouseimg,titelimg:TS2DLimage;
       property font:TS2DLNeheFont read Ffont write Ffont;
       property delay:longint read Fdelay write Fdelay;
       constructor create;
       destructor destroy;override;
     end;

implementation

constructor Ttiteldia.create;

begin
  inherited create;
  delay:=20;
  slagzinnen:=Tstringlist.create;
  slagzinnen.loadfromfile('slagzin.txt');
  huidige_slagzin:=0;
end;

procedure Ttiteldia.DoStartState();

begin
  inherited DoStartState();
  s2dldraw.clearcolor(1.0,1.0,1.0);
  delay_time:=-1;
  returncode:=rt_continue;
  fade_out_start:=1000000000;;
end;

procedure Ttiteldia.DoendState();

begin
  active:=false;
  inherited DoendState();
end;

procedure Ttiteldia.DoUpdate(GameTime:longint);

var i:longint;
    coordx,coordy:word;

begin
  inherited DoUpdate(gameTime);
  delay_time:=delay_time+gameTime;
  if delay_time>huidige_slagzin_start+4000 then
    begin
      huidige_slagzin_start:=delay_time;
      inc(huidige_slagzin);
      if huidige_slagzin>=slagzinnen.count then
        huidige_slagzin:=0;
    end;
  if delay_time>fade_out_start+1500 then
    returncode:=return_after_fade;
end;

procedure Ttiteldia.DoDraw();

var s:integer;
    i,n:cardinal;
    slagzin_tijd:longint;
    q,init_factor,init_factor2,fade_out_factor,fade_out_factor2,slagzin_factor:single;
    t:string;

begin
  inherited DoDraw();

  s2dldraw.clearcolor(1,1,1);
  s2dldraw.clear;

  if delay_time>0 then
    n:=delay_time
  else
    n:=1;

  if n<1000 then
    init_factor:=n/1000
  else
    init_factor:=1;

  if delay_time>fade_out_start then
    fade_out_factor:=(delay_time-fade_out_start)/1000
  else
    fade_out_factor:=1;

  init_factor2:=init_factor*init_factor;
  fade_out_factor2:=fade_out_factor*fade_out_factor;

  s2dldraw.setcolor(1,1,1,1);
  balkboven.drawtiled(0,0,25,1);
  s2dldraw.setcolor(1,1,1,1);
  titelimg.draw(0,345);

  if fade_out_factor=1 then
    s2dldraw.setcolor(0.15,0.19,0.50,init_factor2)
  else
    s2dldraw.setcolor(0.15,0.19,0.50,1-fade_out_factor2);

{  font.writetextstretch(50,50,1.2/init_factor,'free pascal');}
  font.writetextstretch(150,50,2,'free pascal');
  if fade_out_factor=1 then
    s2dldraw.setcolor(0.4,0.4,0.4,init_factor2)
  else
    s2dldraw.setcolor(0.4,0.4,0.4,1-fade_out_factor2);
  font.writetextstretch(155,150,0.6,'een presentatie door Danil Mantione');


  slagzin_tijd:=delay_time-huidige_slagzin_start;
  if slagzin_tijd<1000 then
    slagzin_factor:=-1
  else if slagzin_tijd<2000 then
    slagzin_factor:=(slagzin_tijd-2000)/1000
  else if slagzin_tijd<3000 then
    slagzin_factor:=0
  else if slagzin_tijd<4000 then
    slagzin_factor:=(slagzin_tijd-3000)/1000
  else
     slagzin_factor:=1;

  q:=1-abs(slagzin_factor);
  if fade_out_factor=1 then
    begin
      if q>init_factor2 then
        q:=init_factor2;
    end
  else
    begin
      if q>(1-fade_out_factor2) then
        q:=(1-fade_out_factor2);
    end;
  s2dldraw.setcolor(0.3,0.5,0.8,q);
  font.writetextstretch(320+trunc(300*slagzin_factor),300,0.6,slagzinnen[huidige_slagzin]);

  if fade_out_factor=1 then
    s2dldraw.setcolor(1/15,1/15,1/15,init_factor)
  else
    s2dldraw.setcolor(1/15,1/15,1/15,1-fade_out_factor);

  s2dldraw.setcolor(0,0,0,1);
  s:=delay_time div 1000;
  font.WriteTextStretch(0,586,0.25,'FPS:'+IntToStr(S2DLDraw.FPS));

  s2dldraw.setcolor(1,0,0,1);
  mouseimg.draw(mouse.x-16,mouse.y-16);
end;

procedure Ttiteldia.DoInput();

begin
  returncode:=rt_continue;
  Inherited DoInput();
  if keyboard.keystate[SDLK_LEFT] or mouse.rightbutton then
    begin
      fade_out_start:=delay_time;
      return_after_fade:=rt_vorige_dia;
    end;
  if (keyboard.keystate[SDLK_RIGHT]) or (keyboard.keystate[SDLK_SPACE]) or
     mouse.leftbutton then
    begin
      fade_out_start:=delay_time;
      return_after_fade:=rt_volgende_dia;
    end;
  if keyboard.keystate[SDLK_UP] then
    returncode:=rt_vorige_dia_snel;
  if keyboard.keystate[SDLK_DOWN] then
    returncode:=rt_volgende_dia_snel;
end;

destructor Ttiteldia.destroy;

begin
  slagzinnen.free;
end;

end.

